<template>
	<div class="common-page device-manage">

		<div class="option page-row">
			<!--工具栏-->
			<div class="head-container">
				<!-- 搜索 -->
				<label class="el-form-item-label" style="font-weight: 500;">调度单号</label>
				<el-input v-model="query.odd" clearable size="small" placeholder="请输入调度单号" style="width:180px;"/>

				<label class="el-form-item-label" style="font-weight: 500;">车辆类型</label>
				<el-select v-model="query.carclass" placeholder="请选择卡车类型" style="width:180px;">
					<el-option v-for="(obj,index) in carTypeData" :label="obj.name" :value="obj.name" :key="index"></el-option>
				</el-select>
				
				<el-button size="mini" type="success" icon="el-icon-search" @click="toSearch">搜索</el-button>
				<el-button size="mini" icon="el-icon-refresh" @click="clearLimit">重置</el-button>
			</div>
		</div>
    	<!-- 表格 -->
		<div class="panel-bottom page-row">
			<h3>人工调度管理</h3>
			<div class="ctin-box">
				<div class="content-within">
					<div class="content-fix">
						<div class="toolbar">
							<el-button type="primary" @click="jumpTo()">人工调度</el-button>
						</div>
						<div class="content">
							<el-table :data="tableData" v-loading="loading" border style="width:auto" :row-class-name="tableRowClassName" height="60vh">
								<el-table-column prop="odd" label="调度单号" align="center"></el-table-column>
								<el-table-column prop="carclass" label="车辆类型" align="center"></el-table-column>
								<el-table-column prop="carNo" label="车牌号" align="center"></el-table-column>
								<el-table-column prop="createTime" label="调度时间" align="center"></el-table-column>
								<el-table-column prop="endTime" label="调度截止日期" align="center"></el-table-column>
								<el-table-column prop="finishTime" label="完成调度时间" align="center"></el-table-column>
								<el-table-column prop="destination" label="调度目的地" align="center"></el-table-column>
								<el-table-column prop="carshow" label="说明" align="center"></el-table-column>
								<el-table-column label="操作" align="center" fixed="right">
									<template slot-scope="scope">
										<!-- <el-button size="mini" type="success" icon="el-icon-view" @click="showCars(scope.row)"></el-button> -->
										<el-button size="mini" type="danger" icon="el-icon-delete" @click="toDelete(scope.row)"></el-button>
									</template>
								</el-table-column>
							</el-table>
							<!--分页组件-->
							<el-pagination :total="total" :current-page="page" style="margin-top: 8px;" layout="total, prev, pager, next, sizes" @size-change="sizeChange" @current-change="pageChange" />
						</div>
					</div>
				</div>
			</div>
		</div>
		<!-- 表单渲染 -->
		<el-dialog append-to-body :close-on-click-modal="true" :visible.sync="form.visible" title="调度详情" width="700px">
			<el-form size="small" label-width="100px">
				<el-form-item label="调度车辆">
					<div class="checkboxViews">
						<div v-for="(obj,index) in carInformationData" :key="index">{{obj}}</div>
					</div>
				</el-form-item>
				<el-form-item label="调度时长">
					<div>{{dispatchDuration}}</div>
				</el-form-item>
			</el-form>
		</el-dialog>

	</div>
</template>

<script>
import { Tools, HttpReq, Dates} from '@/assets/js/common.js';

export default {
	name: 'CarManualSchedulingManagement',
	components: {},
	data() {
		return {
			loading: false,
			page: 1,
			size: 10,
			total: 0,
			query:{},
			carTypeData:[],
			tableData: [],
			selectList:[],
			carInformationData:[],
			dispatchDuration:'',
			form: {
				title:'',
				visible:false,
				reqType:'add',
				status:{cu:0},
				item:{},
			},
			rules: {
				// number: [
				// 	{required: true, message: '请输入车牌号', trigger: 'blur' }
				// ],
			},
		}
	},
	mounted() {
		var that = this;
		this.$nextTick(() => {
			this.loadData();
		})
	},
	methods: {
		loadData() {
			var sort = 'id,desc';
			var param = this.query;
			param.page = this.page - 1;
			param.size = this.size;
			param.sort = sort;
			
			this.$nextTick(()=>{
				HttpReq.truckDispatching.manualSchedulingQuery(param).then((res) => {
					if(res.code == 200){
						this.loading = false;
						this.tableData = res.data.content;
						this.total = res.data.totalElements;
					}
				})
				//获取车辆类型
				HttpReq.truckDispatching.carTypeQuery({size:9999}).then((res) => {
					if(res.code == 200){
						this.carTypeData = res.data.content;
					}
				})
			})

		},
		tableRowClassName({row, rowIndex}) {
			if (rowIndex === 1) {
				return 'warning-row';
			} else if (rowIndex === 3) {
				return 'success-row';
			}
			return '';
		},
		jumpTo(){
			this.$router.push('/IntelligentDispatchManagement/carManualScheduling')
		},
		// 点击搜索
		toSearch() {
			this.page = 1;
			this.loadData();
		},
		// 重置搜索
		clearLimit(){
			this.query = {};
			this.loadData()
		},
		pageChange(e) {
			this.page = e
			this.loadData()
		},
		sizeChange(e) {
			this.page = 1
			this.size = e
			this.loadData()
		},
		//查看调度车辆
		showCars(item){
			let code = item.odd;
			this.dispatchDuration = item.duration;
			this.form.visible = true;
			this.carInformationData = JSON.parse(item.carNo);
		},
		//删除提示
		toDelete(item) {
			var id = item.id;
			var itemAll = item;
			this.$confirm('确认删除该条数据吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then((e) => {
				this.reqRemoveProject([id],itemAll)
			}).catch((e) => {})
		},
		//删除调度
		reqRemoveProject(item,itemAll){
			//删除调度
			HttpReq.truckDispatching.manualSchedulingDel(item).then((res) => {
				if(res.status == 400){
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}else{
					this.$notify({
						title: '删除成功！',
						type: 'success',
						duration: 2500
					});
				}
				this.loadData();
			})
			let obj1 = {...itemAll};
			delete obj1.id;
			obj1.flag = 1;
			//新增到订单历史
			HttpReq.truckDispatching.personRecordingAdd(obj1).then((res) => {
				if(res.code == 200){
					
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) { });

		},
		currentTime(time){
			var date = new Date(time);
			var year = date.getFullYear();        //年 ,从 Date 对象以四位数字返回年份
			var month = date.getMonth() + 1;      //月 ,从 Date 对象返回月份 (0 ~ 11) ,date.getMonth()比实际月份少 1 个月
			var day = date.getDate();             //日 ,从 Date 对象返回一个月中的某一天 (1 ~ 31)
			//修改月份格式
			if (month >= 1 && month <= 9) {
				month = "0" + month;
			}
			//修改日期格式
			if (day >= 0 && day <= 9) {
				day = "0" + day;
			}
			//获取当前系统时间  格式(yyyy-mm-dd hh:mm:ss)
			let currentFormatDate = year + "-" + month + "-" + day;
			return currentFormatDate;
		}
	}
}
</script>

<style rel="stylesheet/scss" lang="scss" scope>
	.el-table .warning-row {
		background: oldlace;
	}
	.el-table .success-row {
		background: #f0f9eb;
	}
	
	.device-manage{
		.panel-bottom{
			.el-button{margin:2px 0;padding:6px 15px;font-size:14px;}
			.btn-groub2{
				display:inline-block;
				.el-button{margin:2px 0;padding:6px 15px;font-size:15px;}
				.el-button--warning {
					background-color: #e6a23c;
					border-color: #e6a23c;
				}
				.el-button--warning:focus,.el-button--warning:hover{background:#ebb563;border-color:#ebb563;}
			}
		}
	}
	.checkboxViews{
		padding-top: 10px;
		padding-left: 10px;
		box-sizing: border-box;
		width: 550px;
		height: 250px;
		border: 1px gainsboro solid;
		overflow-y:scroll;
		overflow-x:hidden;
	}
	.checkboxViews>div{
		display: inline-block;
		width: 24%;
		text-align: center;
	}
	.ecahrt1-dialog{
		display:flex;align-items:center;
		.el-dialog{
			margin-top:inherit !important;display:table !important;width:fit-content;
			.el-form-item{margin-right:0;}
		}

		.el-dialog__header{height:0;padding:0;display:block;}
		.form-body{
			border:1px solid #999;width:800px;height:500px;position:relative;
			>div{position:absolute;top:0;left:0;height:100%;width:100%;}
		}
	}
</style>
